var config = {};

// Application configuration
config.appPort = 8888;

config.masterAddr = 'localhost:1666';
config.masterUser = 'jrobinson';

config.secretKey = 'mysupersecretkey';
config.cookieLife = 1000 * 60 * 60 * 12 * 1;      // ms * s * m * h * d
config.sessIDKey = 'SESS';
config.loginCKey = '_arg';

config.requestTime = 1000 * 30;     // ms * s
config.requestTimeMin = 1000 * 15;
config.requestTimeMax = -1;

// Redis DB info -- Configure to match Redis database configuration
var redisUrl;
var redisUrlDefault = 'redis://:@127.0.0.1:6379/0';

if (typeof(process.env.REDISTOGO_URL) != 'undefined') {
    redisUrl = url.parse(process.env.REDISTOGO_URL);
}
else redisUrl = url.parse(redisUrlDefault);

config.redisProtocol = redisUrl.protocol.substr(0, redisUrl.protocol.length - 1);
config.redisHost = redisUrl.hostname;
config.redisPort = redisUrl.port;
config.redisUser = redisUrl.auth.split(':')[0];
config.redisPass = redisUrl.auth.split(':')[1];
config.redisDatabase = redisUrl.path.substring(1);

module.exports = config;